<?php
/**
 * @file
 * Author Pane Popup inc.
 */

/**
 * Callback function for popup.
 */
function author_pane_popup_author_pane($account) {
  if ($user_path = drupal_lookup_path('source', $_POST['url'])) {
    $account = menu_get_object('user', 1, $user_path);
  }
  else {
    $account = menu_get_object('user', 1, $_POST['url']);
  }
  print theme('author_pane',
    array(
      'account' => $account,
      'caller' => NULL,
      'picture_preset' => 'thumbnail',
      'context' => NULL,
      'disable_css' => FALSE,
    )
  );
}

/**
 * Based on visibility setting this function returns TRUE/FALSE.
 */
function author_pane_popup_visibility_pages() {
  static $page_match;
  $php_access = user_access('use PHP for Author Pane Popup visibility');

  // Cache visibility result if function is called more than once.
  if (!isset($page_match)) {

    $visibility = variable_get('author_pane_popup_visibility_options', 0);
    $setting_pages = variable_get('author_pane_popup_visibility_pages', AUTHOR_PANE_POPUP_PAGES);

    // Match path if necessary.
    if (!empty($setting_pages)) {
      // Convert path to lowercase. This allows comparison of the same path
      // with different case. Ex: /Page, /page, /PAGE.
      $pages = drupal_strtolower($setting_pages);
      if ($visibility < 2) {
        // Convert the Drupal path to lowercase.
        $path = drupal_strtolower(drupal_get_path_alias($_GET['q']));
        // Compare the lowercase internal and lowercase path alias (if any).
        $page_match = drupal_match_path($path, $pages);
        if ($path != current_path()) {
          $page_match = $page_match || drupal_match_path($_GET['q'], $pages);
        }
        // When $visibility has a value of 0, the tracking code is displayed on
        // all pages except those listed in $pages. When set to 1, it
        // is displayed only on those pages listed in $pages.
        $page_match = !($visibility xor $page_match);
      }
      elseif (module_exists('php') && $php_access) {
        $page_match = php_eval($setting_pages);
      }
      else {
        $page_match = FALSE;
      }
    }
    else {
      $page_match = TRUE;
    }

  }
  return $page_match;
}

/**
 * Passing php values to Drupal js.
 */
function author_pane_popup_load_js($author_pane_popup_js) {
  drupal_add_js(array(
    'author_pane_popup_triggers' => $author_pane_popup_js['author_pane_popup_triggers'],
    'author_pane_popup_qtip_config' => $author_pane_popup_js['author_pane_popup_qtip_instance'],
    'author_pane_popup_loading_text' => $author_pane_popup_js['author_pane_popup_loading_text'],
  ), 'setting'
  );
}

/**
 * Get trigger classes/ids.
 */
function author_pane_popup_get_triggers() {
  $trigger = variable_get('author_pane_popup_jquery_selectors', '.username' . "\n");
  $trigger = explode("\n", $trigger);
  // Trim all entries.
  $trigger = array_map('trim', $trigger);
  // Filter out empty lines.
  $trigger = array_filter($trigger);

  $triggers = array();

  foreach ($trigger as $this_trigger) {
    $triggers[] = $this_trigger;
  }
  return implode(',', $triggers);
}
